Skip site navigation (1)Skip section navigation (2)
Date:      Thu, 27 Jan 2011 12:01:24 +0000 (UTC)
From:      Peter Holm <pho@FreeBSD.org>
To:        src-committers@freebsd.org, svn-src-projects@freebsd.org
Subject:   svn commit: r217934 - projects/stress2/misc
Message-ID:  <201101271201.p0RC1OWs015371@svn.freebsd.org>

next in thread | raw e-mail | index | archive | help
Author: pho
Date: Thu Jan 27 12:01:24 2011
New Revision: 217934
URL: http://svn.freebsd.org/changeset/base/217934

Log:
  Deadlock scenario based on kern/154228 added.

Added:
  projects/stress2/misc/gjournal.sh   (contents, props changed)

Added: projects/stress2/misc/gjournal.sh
==============================================================================
--- /dev/null	00:00:00 1970	(empty, because file is newly added)
+++ projects/stress2/misc/gjournal.sh	Thu Jan 27 12:01:24 2011	(r217934)
@@ -0,0 +1,70 @@
+#!/bin/sh
+
+#
+# Copyright (c) 2011 Peter Holm <pho@FreeBSD.org>
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+# 1. Redistributions of source code must retain the above copyright
+#    notice, this list of conditions and the following disclaimer.
+# 2. Redistributions in binary form must reproduce the above copyright
+#    notice, this list of conditions and the following disclaimer in the
+#    documentation and/or other materials provided with the distribution.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+# SUCH DAMAGE.
+#
+# $FreeBSD: projects/stress2/misc/sendfile.sh 199142 2009-11-10 16:47:48Z pho $
+#
+
+# Deadlock scenario based on kern/154228, fixed in r217880.
+
+. ../default.cfg
+
+size="2g"
+m=$((mdstart + 1))
+mount | grep /media    | grep -q /dev/md && umount -f /media
+mount | grep $mntpoint | grep -q /dev/md && umount -f $mntpoint
+mdconfig -l | grep -q md$mdstart &&  mdconfig -d -u $mdstart
+mdconfig -l | grep -q md$m       &&  mdconfig -d -u $m
+mdconfig -a -t swap -s $size -u $mdstart || exit 1
+
+gjournal load
+gjournal label -s $((200 * 1024 * 1024)) md$mdstart
+sleep .5
+newfs -J /dev/md$mdstart.journal > /dev/null
+mount -o async /dev/md$mdstart.journal $mntpoint
+
+here=`pwd`
+cd $mntpoint
+truncate -s 1g image
+mdconfig -a -t vnode -f image -u $m
+bsdlabel -w md$m auto
+newfs md${m}$part > /dev/null
+mount /dev/md${m}$part /media
+# dd will suspend in wdrain
+dd if=/dev/zero of=/media/zero bs=1M 2>&1 | egrep -v "records|transferred"
+while mount | grep /media | grep -q /dev/md; do
+	umount /media || sleep 1
+done
+mdconfig -d -u $m
+cd $here
+
+gjournal sync
+while mount | grep $mntpoint | grep -q /dev/md; do
+	umount $mntpoint || sleep 1
+done
+gjournal stop md$mdstart
+gjournal unload
+mdconfig -d -u $mdstart



Want to link to this message? Use this URL: <https://mail-archive.FreeBSD.org/cgi/mid.cgi?201101271201.p0RC1OWs015371>